/******************************* Copyright notice *******************************
Copyright (C)2002 by Andrei Loskutov <loskutov@gmx.de>. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
********************************************************************************/

package adiag.connection.command;

import adiag.connection.Command;
import adiag.model.BVException;

/**
 * @author Andy the Great
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Diff implements Command {

    /* (non-Javadoc)
     * @see adiag.connection.Command#exec(java.lang.Object)
     */
    public void exec(Object[] parameters) throws BVException {        
        String [] cmd = new String [parameters.length];
        for (int i = 0; i < cmd.length; i++) {
            cmd[i] = "" + parameters[i];
        }
        exec(cmd);
    }

    private void exec(String[] cmd) throws BVException {
        Runtime rt = Runtime.getRuntime();
        String path = cmd.length > 0 ? cmd [0] : "null";
        try {
            rt.exec(cmd, null); 
        } catch(Exception e) {
            throw new BVException("Diff command failed:\n"
                + "'diff' tool executable may be not in path or path is wrong\n"
                + "Please ensure, that diff tool is in your PATH\n"
                + "or check your current diff tool path for misspelling:\n'"
                + path + "'",  e );
        }
    }

}
